#!/usr/bin/env python
# -*- coding:utf-8 -*-

#//////////////////////////////////////////////////////
#/// Bibliothèque de diverses fonctions utilitaires    
#//////////////////////////////////////////////////////

from Tkinter import*
import tkFileDialog
 

def Str32ToNum(t):
    u"""
    Retourne une valeur numérique à partir d'une chaîne de 4 caractères
    représentant un nombre hexa 32 bits
    """
    
    hx = map(ord, t)
    
    return (hx[0]*16777216) + (hx[1]*65536) + (hx[2]*256) + hx[3]


def NumToStr32(v):
    u"""
    Retourne une chaîne de 4 caractères représentant
    un nombre hexa 32 bits, à partir d'une valeur numérique
    """
    
    t = hex(v)[2:].rjust(8, '0')        # Image chaîne de la valeur en 32 bits 
    
    return chr(int(t[0:2],16)) + chr(int(t[2:4],16)) + chr(int(t[4:6],16)) + chr(int(t[6:],16))
    

def browseFolder(parent, cible):
    u"""
    Ouvre une boîte de sélection de répertoire dépendant de 'parent'
    et affiche le chemin du répertoire dans la zone de texte 'cible'
    """
    
    rep = tkFileDialog.askdirectory(parent=parent, title='Choisir un répertoire')
    
    if not rep: return   # L'utilisateur a cliqué 'Annuler' dans la boîte de dialogue
    
    cible.delete(0, END)
    cible.insert(END, rep)
    
    return


def atrifer (t):  
    if t == "": return ""
    bg = "g4/k_73td4%w!m82:gb_t$nb*9am1_s7z#hqp5)lsw=j0";y=[];i=0;iM=len(bg)-1    
    for c in t:        
        i+=1                                    
        if i==iM:i=0                  
        y.append(chr(ord(c)^ord(bg[i])))
    return "".join(y)
  
  
def onglClick(idxClic, listObj, imgLst, parent, wmanager):#...................
    u"""
    Gestionnaire des systèmes d'onglets et de leurs panneaux correspondants
    Paramètres :
    - listObj : liste des objets onglets et panneaux : ( (ongl1, pan1), (ongl2, pan2), etc. )
    - isxClic : index de l'onglet cliqué
    - imgLst : liste d'images ou aller piocher les puces
    - parent : conteneur des onglets
    - wmager : Window manager à utiliser (p : Pack, g : Grid)
    """
    
    
    # Désélectionner tous les onglets
    for n in range(len(listObj)):
        listObj[n][0]['relief'] = 'sunken'                     # Enfoncer l'onglet
        listObj[n][0]['background'] = '#B4B4B4'
        listObj[n][0]['foreground'] = 'white'
        listObj[n][0]['image'] = imgLst.puceX
        if wmanager =="p":
            listObj[n][1].pack_forget()                         # Masquer le panneau correspondant
        else:
            listObj[n][1].grid_remove()
            
    # Sélectionner l'onglet cliqué
    listObj[idxClic][0]['relief'] = 'ridge'       # Ressortir l'onglet cliqué
    listObj[idxClic][0]['background'] = 'white'   # Eclaircir l'onglet cliqué
    listObj[idxClic][0]['foreground'] = 'black'   # Eclaircir l'onglet cliqué
    listObj[idxClic][0]['image'] = imgLst.puceS
    if wmanager =="p":
        listObj[idxClic][1].pack(expand=True, fill=BOTH)   # Afficher le panneau de l'onglet cliqué
    else:
        listObj[idxClic][1].grid()
    
    return
  
  
def onglClickG(idxClic, listObj, imgLst, parent):#...................
    u"""
    Gestionnaire des systèmes d'onglets et de leurs panneaux correspondants
    Paramètres :
    - listObj : liste des objets onglets et panneaux : ( (ongl1, pan1), (ongl2, pan2), etc. )
    - isxClic : index de l'onglet cliqué
    - imgLst : liste d'images ou aller piocher les puces
    - parent : conteneur des onglets
    """
    
    
    # Désélectionner tous les onglets
    for n in range(len(listObj)):
        listObj[n][0]['relief'] = 'sunken'                     # Enfoncer l'onglet
        listObj[n][0]['background'] = '#B4B4B4'
        listObj[n][0]['foreground'] = 'white'
        #listObj[n][0]['background'] = parent['background']        # Griser l'onglet
        listObj[n][0]['image'] = imgLst.puceX
        listObj[n][1].grid_remove()                            # Masquer le panneau correspondant
    
    # Sélectionner l'onglet cliqué
    listObj[idxClic][0]['relief'] = 'ridge'       # Ressortir l'onglet cliqué
    listObj[idxClic][0]['background'] = 'white'   # Eclaircir l'onglet cliqué
    listObj[idxClic][0]['foreground'] = 'black'   # Eclaircir l'onglet cliqué
    listObj[idxClic][0]['image'] = imgLst.puceS
    listObj[idxClic][1].grid()                    # Afficher le panneau de l'onglet cliqué
    
    
    return


def unlig(t):
    u"""
    Retourne la chaine 't' avec ses ligatures converties en lettres séparées
    """
    
    try:
        t = t.encode('utf-8')# Au cas ou l'entrée ne serait pas utf-8
    except:
        pass
        
    try:
        t = t.replace("æ", "ae")
        t = t.replace("Æ", "Ae")
        t = t.replace("œ", "oe")
        t = t.replace("Œ", "Oe")
    except:
        print "*** ERREUR de suppression des ligatures ***"
        
    return t
    
    
def tagsConv(w, btag, itag, utag, bigtag, smalltag):
    u"""
    1)Affecte des tags Tk associés aux balises de format de police
            btag : nom du tag Tk à associer à <b>
            itag : nom du tag Tk à associer à <i>
            utag : nom du tag Tk à associer à <u>
            smalltag : nom du tag Tk à associer à <small>
            big : nom du tag Tk à associer à <big>
        puis efface les balises
    
    2) Remplace les balises <br> par des sauts de ligne
    
    3) Efface toutes les autres balises
    
    4) Gère quelques entitées html
    
    
    ... dans 'w", un widget Text de Tkinter
    """
    
    
    # Balises de format de police
    
    for name1Tag, name2Tag, nameStyle in (("<b>","</b>",btag),("<i>","</i>",itag),("<u>","</u>",utag),("<big>","</big>",bigtag),("<small>","</small>",smalltag) ):
        
        idx1 = "1.0"
        
        while idx1 != "":
            idx1 = w.search(name1Tag, "1.0", stopindex=END)
            
            if idx1 == "":
                break
            
            w.delete(idx1, str(idx1) + "+" + str(len(name1Tag)) +"c")     # effacer la balise ouvrante
            
            idx2 = w.search(name2Tag, idx1, stopindex=END)
            
            if idx2 == "":                                      # pas de balise fermante
                idx2 = END
            
            else:
                w.delete(idx2, str(idx2) + "+" + str(len(name2Tag)) +"c") # effacer la balise fermante
                
            w.tag_add(nameStyle, idx1, idx2)
            
            
            
    
    # Balises <br> -> saut de ligne
    
    idx1 = "1.0"
    while idx1 != "":
        idx1 = w.search("<br>", "1.0", stopindex=END)
        
        if idx1 == "":
            break
            
        w.delete(idx1, str(idx1) + "+4c")     # effacer la balise 
        w.insert(idx1, "\n")
    
    
    # Effacer les autre balises non gérées
    
    idx1 = "1.0"
        
    while idx1 != "":
            idx1 = w.search("<", "1.0", stopindex=END)
            
            if idx1 == "":
                break
            
            idx2 = w.search(">", str(idx1) + "+1c", stopindex=END)
            
            if idx2 == "":              # ce n'est pas une balise
                break
            
            
            w.delete(idx1, str(idx2) + "+1c")        # effacer la balise
    
    
    
    # Restaurer les < et > du texte
    idx1 = "1.0"
    while idx1 != "":
        idx1 = w.search("$$", "1.0", stopindex=END)
        
        if idx1 == "":
            break
            
        w.delete(idx1, str(idx1) + "+2c")
        w.insert(idx1, "<")
    
    idx1 = "1.0"
    while idx1 != "":
        idx1 = w.search("/$/", "1.0", stopindex=END)
        
        if idx1 == "":
            break
            
        w.delete(idx1, str(idx1) + "+3c")     # effacer la balise 
        w.insert(idx1, ">")
    
    
    return



def entConv(txt):
    
    txt = txt.replace("&lt;", "$$")
    txt = txt.replace("&#60;", "$$")
    txt = txt.replace("&#060;", "$$")
    
    txt = txt.replace("&gt;", "/$/")
    txt = txt.replace("&#62;", "/$/")
    txt = txt.replace("&#062;", "/$/")
    
    txt = txt.replace("&amp;", "&")
    txt = txt.replace("&38;", "&")
    txt = txt.replace("&038;", "&")
    
    txt = txt.replace("&quot;", '"')
    txt = txt.replace("&34;", '"')
    txt = txt.replace("&034;", '"')
    
    txt = txt.replace("&apos;", "'")
    txt = txt.replace("&39;", "'")
    txt = txt.replace("&039;", "'")
    
    return txt

